<?php
 
namespace Silber\Bouncer\Database;
 
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Facades\Auth;
use App\Models\System\Menu;



class Ability extends Model
{
    use Concerns\IsAbility, SoftDeletes;
 
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = ['name', 'title','menu_id','created_by','updated_by'];
 
    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'int',
        'entity_id' => 'int',
        'only_owned' => 'boolean',
    ];
 
    /**
     * Constructor.
     *
     * @param array  $attributes
     */
    public function __construct(array $attributes = [])
    {
        $this->table = Models::table('abilities');
 
        parent::__construct($attributes);
    }


    public static function boot()
    {
        parent::boot();
 
	static::creating(function ($query){
            $query->created_by = Auth::id();
            $query->updated_by = Auth::id();
        });


	static::updating(function ($query){
            $query->updated_by = Auth::id();
        });
    }
    public function menu()
    {
        return $this->belongsTo(Menu::class);
    }
}
